<?php /*
Plugin Name: RV Menu Tree
Version: 2.1.a
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=238
Description: Replaces the categories in the menu bar with a nicer one (javascript).
Author: rvelices
Author URI: http://www.modusoptimus.com
*/

if (!function_exists('rv_ua_is_handheld'))
{
	function rv_ua_is_handheld()
	{
		if ( isset($_SESSION['is_handheld']) )
			return $_SESSION['is_handheld'];
		$ret=false;
		if ( strpos($_SERVER['HTTP_USER_AGENT'], 'BlackBerry')!==false )
			$ret=true;
		if ( session_id()!="" )
			$_SESSION['is_handheld']=$ret;
		return $ret;
	}
}

add_event_handler('get_categories_menu_sql_where', 'rv_mt_get_categories_menu_sql_where', EVENT_HANDLER_PRIORITY_NEUTRAL, 3 );

function rv_mt_get_categories_menu_sql_where($where, $expand, $filter)
{
	if (rv_ua_is_handheld()) return $where;
	add_event_handler('blockmanager_apply', 'rv_mt_menubar_categories');

	if ($expand)
		return $where;
	if ($filter)
	{
		global $rv_mt_all_open;
		$rv_mt_all_open = true;
		return $where;
	}

	global $page;
	if ( !isset($page['category']) )
		$where = 'id_uppercat IS NULL OR uppercats REGEXP \'^[0-9]+,[0-9]+$\'';
	else
	{
		$where = 'id_uppercat is NULL
  OR uppercats LIKE "'.$page['category']['upper_names'][0]['id'].',%"
  OR uppercats REGEXP \'^[0-9]+,[0-9]+$\'';
	}
	return $where;
}

function rv_mt_menubar_categories($menu_ref_arr)
{
	$menu = & $menu_ref_arr[0];

	if (($block = $menu->get_block('mbCategories')) != null)
	{
		global $template, $page, $rv_mt_all_open;

		$dirname = dirname(__FILE__);

		$block->template = $dirname.'/menubar_categories.tpl';

		$template->assign('rvmt', array(
			'PATH' => get_root_url().'plugins/'. basename($dirname).'/',
			'CSS' => str_replace( 'url(', 'url('.get_root_url().'plugins/'.basename($dirname).'/',file_get_contents($dirname.'/rvtree-min.css')),
			'ALL_OPEN' => $rv_mt_all_open,
			'UPPER_IDS' => isset($page['category']['uppercats']) ? array_flip( explode(',', $page['category']['uppercats'])) : null,
			)
		);
	}
}
?>